/***************************************************************************
                          widgetmain.cpp  -  description
                             -------------------
    begin                : Tue May 8 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "widgetmain.h"

#include <qwhatsthis.h>
#include <qtimer.h>
#include <stdlib.h>
#include <string.h>
#include <qlistview.h>
#include <qlistbox.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


#define LENGTH 200
#define LENGTH1 200




widgetMain::widgetMain(QWidget *parent, const char *name) : QWidget(parent,name){
	initDialog();
}

widgetMain::~widgetMain(){
}


void widgetMain::setupQuit(QApplication *a){

	QTimer *internalTimer = new QTimer( this );

	getconfig();

	connect( internalTimer, SIGNAL(timeout()), this, SLOT(typval()) );
	getval();
	neuwin();
	mosixstatus();
	labelconf();


	QTimer *proctimer = new QTimer( this );
	proctimer->start( 10000 );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit()) );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit_status()) );



	internalTimer->start( 500 );


	QObject::connect( QPushButton_70, SIGNAL(clicked()), this, SLOT( refreshitmanual()) );
	QObject::connect( QPushButton_73, SIGNAL(clicked()), this, SLOT( refreshit_status_manual()) );

	QObject::connect(QPushButton_1, SIGNAL(clicked()), a, SLOT(quit()) );

	QObject::connect(QScrollBar_1, SIGNAL(sliderMoved ( int )), this, SLOT(view( int  )) );
	QObject::connect(QScrollBar_1, SIGNAL(valueChanged ( int )), this, SLOT(view( int  )) );


}




void widgetMain::view( int value ) {


	int current_h=0;

	current_h=QGroupBox_1->height();
  QGroupBox_1->setGeometry ( 20, -value, 450, current_h );

}





void widgetMain::getconfig() {

	char mapentry[LENGTH];
	char *leer1="0";
	int counter=0;
	FILE *fp;
	int character='#';
	int character1=' ';
	int character2='\t';
	int lang=0;
	char hostname[256][LENGTH];
	char tmp[256][LENGTH];
	char hostrange[256][LENGTH];

	char many[256][LENGTH];
	int howmany=0;
  char *sub_string;
  char *sub_string1;
	int p=0;
	int pi=0;
	char pc[4];
	int range=0;
	int label=0;
	int labelheight=0;
	char hostnr[4];
	int current_h=0;
	int current_range=0;
	int current_label52_h=0;
	int current_label50_h=0;
	int current_label110_h=0;
	int current_label111_h=0;
	int current_refresh=0;
	int current_auto_refresh=0;
	int current_ns_box=0;
	int current_load_box=0;

	int j=0;
	int k=0;

	for(k=0;k<256;k++) {
	strcpy(hostname[k], "");

	}


        if ((fp=fopen("/etc/mosix.map", "r"))==NULL) {
        printf("This is not MOSIX\n");
				exit(1);
        }

        while (!feof(fp)) {

                        fgets(mapentry, LENGTH, fp);

                        if ( ((strchr(mapentry, character))==NULL)&&((strlen(mapentry))>1) ) {
		                     if ((leer1=strchr(mapentry, character2))==NULL) {
                                leer1=strchr(mapentry, character1);
						                    leer1++;
            				            strcpy(tmp[counter], leer1);
                    				    lang=strcspn(tmp[counter], " ");



														    } else {
						                    leer1++;
            				            strcpy(tmp[counter], leer1);
                    				    lang=strcspn(tmp[counter], "\t");
																																		}

														
	range=0;
	strcpy(many[counter], leer1);																
  printf("%s\n", strtok(many[counter], " "));
	sub_string=strtok(NULL, " ");
	

	howmany=atoi(sub_string);
	if (howmany!=1) {

	range=1;
	for (p=0; p<=howmany-1; p++) {

 		                    strncpy(hostrange[counter], leer1, lang);
												  printf("%s\n", strtok(hostrange[counter], "."));
													sub_string1=strtok(NULL, ".");
													sub_string1=strtok(NULL, ".");
													sub_string1=strtok(NULL, ".");



                        	pi=atoi(sub_string1);
													pi=pi+p;

												sprintf(pc, "%d", pi);

	 											while(j<LENGTH) {
												hostname[counter][j]=0;
												j++;
                                   }

 		                    strncpy(hostname[counter], leer1, lang-(strlen(sub_string1)));
												strcat(hostname[counter], pc);
                        counter++;

												j=0;

					}

		}



           						if(range==0) {
  											while(j<LENGTH) {
												hostname[counter][j]=0;
												j++;
                                    }
	                      strncpy(hostname[counter], leer1, lang);
                        counter++;
												j=0;
																		}
  	                    }
               }

        fclose(fp);


for(label=0;label<counter; label++) {

	labelheight=(label+1)*20;

	sprintf(hostnr, "%d", label+1);

  QLabel_stat[label]= new QLabel(QGroupBox_1,"NoName");
  QLabel_stat[label]->setGeometry(5,labelheight+20,25,20);
  QLabel_stat[label]->setMinimumSize(0,0);
  QLabel_stat[label]->setFont(QFont("helvetica", 12, 50));
  QLabel_stat[label]->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
  QLabel_stat[label]->setText(hostnr);
  QLabel_stat[label]->setMargin(1);
  QLabel_stat[label]->setFrameStyle( QFrame::Panel | QFrame::Sunken );


  QPushButton_host[label]= new QPushButton(QGroupBox_1, hostname[label]);
  QPushButton_host[label]->setGeometry(30,labelheight+20,110,20);
	QPushButton_host[label]->setMinimumSize(0,0);
	QPushButton_host[label]->setText(hostname[label]);

	QObject::connect( 	QPushButton_host[label], SIGNAL(clicked()), this, SLOT( neuwin1()) );

  QSlider_host[label]= new QSlider(QGroupBox_1,hostname[label]);
  QSlider_host[label]->setGeometry(140,labelheight+30,120,10);
  QSlider_host[label]->setMinimumSize(0,0);
  QSlider_host[label]->setValue(0);
  QSlider_host[label]->setRange(0,100000);
  QSlider_host[label]->setOrientation(QSlider::Horizontal);

	QObject::connect(  QSlider_host[label], SIGNAL(valueChanged(int)), this, SLOT(setspeed(int)) );

	QLCDNumber_host[label]= new QLCDNumber(QGroupBox_1, hostname[label]);
  QLCDNumber_host[label]->setGeometry(260,labelheight+20,50,20);
  QLCDNumber_host[label]->setMinimumSize(0,0);
  QLCDNumber_host[label]->display("0");
  QLCDNumber_host[label]->setNumDigits(6);
  QLCDNumber_host[label]->setSegmentStyle (QLCDNumber::Flat);

	QObject::connect(  QSlider_host[label], SIGNAL(valueChanged(int)),   QLCDNumber_host[label], SLOT(display(int)) );

  QProgressBar_host[label]= new QProgressBar(QGroupBox_1, hostname[label]);
  QProgressBar_host[label]->setGeometry(310,labelheight+20,130,20);
  QProgressBar_host[label]->setMinimumSize(0,0);
	QProgressBar_host[label]->setTotalSteps (150);


	current_h=QGroupBox_1->height();
	current_h=current_h+20;
	QGroupBox_1->setGeometry ( 20, 0, 450, current_h );


	current_range=QScrollBar_1->maxValue ();
	current_range=current_range+20;
	QScrollBar_1->setRange ( 0, current_range );

	current_label52_h=QLabel_52->y();
	current_label52_h=current_label52_h+20;
	QLabel_52->setGeometry ( 10, current_label52_h, 130, 20 );

	current_label50_h=QLabel_50->y();
	current_label50_h=current_label50_h+20;
	QLabel_50->setGeometry ( 140, current_label50_h, 50, 20 );


	current_label110_h=QLabel_110->y();
	current_label110_h=current_label110_h+20;
	QLabel_110->setGeometry ( 10, current_label110_h, 80, 20 );

	current_label111_h=QLabel_111->y();
	current_label111_h=current_label111_h+20;
	QLabel_111->setGeometry ( 140, current_label111_h, 300, 20 );

	current_refresh=QPushButton_73->y();
	current_refresh=current_refresh+20;
  QPushButton_73->setGeometry(10,current_refresh,50,20);

	current_auto_refresh=QCheckBox_2->y();
	current_auto_refresh=current_auto_refresh+20;
	QCheckBox_2->setGeometry(80,current_auto_refresh,140,20);

	current_ns_box=QCheckBox_3->y();
	current_ns_box=current_ns_box+20;
	QCheckBox_3->setGeometry(80,current_ns_box,220,20);

	current_load_box=QCheckBox_4->y();
	current_load_box=current_load_box+20;
	QCheckBox_4->setGeometry(320,current_load_box,120,20);

	}

}







void widgetMain::neuwin1() {

	const  char *hostname;
	const  char *hostname2;
	const QObject *button = sender();

	struct in_addr **ip;
	struct in_addr num;
	struct hostent *host;
	char ipaddr[20];


	hostname=button->name();

	hinten1= new QWidget(0, hostname);
	hinten1->setGeometry(500,300,50,110);
	hinten1->setMinimumSize(0,0);
	hinten1->resize(250, 250);

	QGroupBox *backr = new QGroupBox("",hinten1);
	backr->setGeometry(5, 30, 245,215);
	backr->setMinimumSize(0,0);
	backr->resize(240, 210);


  QPushButton_2= new QPushButton(backr,hostname);
  QPushButton_2->setGeometry(10,70,40,20);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText("on");
  QWhatsThis::add(QPushButton_2,"Click this button to enable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_2, SIGNAL(clicked()), this, SLOT( action_migration()) );


  QPushButton_12= new QPushButton(backr,hostname);
  QPushButton_12->setGeometry(50,70,40,20);
  QPushButton_12->setMinimumSize(0,0);
  QPushButton_12->setText("off");
  QWhatsThis::add(QPushButton_12,"Click this button to disable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_12, SIGNAL(clicked()), this, SLOT( action_nomigration()) );

  QPushButton_81= new QPushButton(backr,hostname);
  QPushButton_81->setGeometry(10,90,40,20);
  QPushButton_81->setMinimumSize(0,0);
  QPushButton_81->setText("yes");
	QObject::connect( QPushButton_81, SIGNAL(clicked()), this, SLOT( action_quiet()) );

	QPushButton_91= new QPushButton(backr,hostname);
  QPushButton_91->setGeometry(50,90,40,20);
  QPushButton_91->setMinimumSize(0,0);
  QPushButton_91->setText("no");
	QObject::connect( QPushButton_91, SIGNAL(clicked()), this, SLOT( action_noquiet()) );

  QPushButton_30= new QPushButton(backr,hostname);
  QPushButton_30->setGeometry(10,110,40,20);
  QPushButton_30->setMinimumSize(0,0);
  QPushButton_30->setText("yes");
	QObject::connect(   QPushButton_30, SIGNAL(clicked()), this, SLOT( action_lstay()) );

  QPushButton_40= new QPushButton(backr,hostname);
  QPushButton_40->setGeometry(50,110,40,20);
  QPushButton_40->setMinimumSize(0,0);
  QPushButton_40->setText("no");
	QObject::connect(   QPushButton_40, SIGNAL(clicked()), this, SLOT( action_nolstay()) );

  QPushButton_50= new QPushButton(backr,hostname);
  QPushButton_50->setGeometry(10,130,40,20);
  QPushButton_50->setMinimumSize(0,0);
  QPushButton_50->setText("yes");
	QObject::connect(   QPushButton_50, SIGNAL(clicked()), this, SLOT( action_block()) );

  QPushButton_60= new QPushButton(backr,hostname);
  QPushButton_60->setGeometry(50,130,40,20);
  QPushButton_60->setMinimumSize(0,0);
  QPushButton_60->setText("no");
	QObject::connect(   QPushButton_60, SIGNAL(clicked()), this, SLOT( action_noblock()) );

  QPushButton_80= new QPushButton(backr,hostname);
  QPushButton_80->setGeometry(10,150,40,20);
  QPushButton_80->setMinimumSize(0,0);
  QPushButton_80->setText("start");
	QObject::connect( QPushButton_80, SIGNAL(clicked()), this, SLOT( action_start()) );


	QPushButton_90= new QPushButton(backr,hostname);
  QPushButton_90->setGeometry(50,150,40,20);
  QPushButton_90->setMinimumSize(0,0);
  QPushButton_90->setText("stop");
	QObject::connect( QPushButton_90, SIGNAL(clicked()), this, SLOT( action_stop()) );

  QPushButton_14= new QPushButton(backr,hostname);
  QPushButton_14->setGeometry(80,180,80,20);
  QPushButton_14->setMinimumSize(0,0);
  QPushButton_14->setText("OK");
  QWhatsThis::add(QPushButton_14,"OK\n");

	QObject::connect( QPushButton_14, SIGNAL(clicked()), this, SLOT( close_config()) );


  QLabel_hostconf5= new QLabel(hinten1,hostname);
  QLabel_hostconf5->setGeometry(10,10,200,20);
  QLabel_hostconf5->setMinimumSize(0,0);
  QLabel_hostconf5->setText("MOSIX-configuration");
  QLabel_hostconf5->setMargin(2);


	if(QCheckBox_3->isChecked()) {

  QLabel_hostconf8= new QLabel(hinten1,hostname);
  QLabel_hostconf8->setGeometry(15,40,80,20);
  QLabel_hostconf8->setMinimumSize(0,0);
  QLabel_hostconf8->setText("hostname:");
  QLabel_hostconf8->setMargin(2);

  QLabel_hostconf9= new QLabel(hinten1,hostname);
  QLabel_hostconf9->setGeometry(15,65,80,20);
  QLabel_hostconf9->setMinimumSize(0,0);
  QLabel_hostconf9->setText("ip-address:");
  QLabel_hostconf9->setMargin(2);

  QLabel_hostconf= new QLabel(hinten1,hostname);
  QLabel_hostconf->setGeometry(100,40,120,20);
  QLabel_hostconf->setMinimumSize(0,0);
  QLabel_hostconf->setMargin(2);
  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );


  QLabel_hostconf7= new QLabel(hinten1,hostname);
  QLabel_hostconf7->setGeometry(100,65,120,20);
  QLabel_hostconf7->setMinimumSize(0,0);
  QLabel_hostconf7->setMargin(2);
  QLabel_hostconf7->setFrameStyle( QFrame::Panel | QFrame::Sunken );

		} else {

  QLabel_hostconf8= new QLabel(hinten1,hostname);
  QLabel_hostconf8->setGeometry(15,60,80,20);
  QLabel_hostconf8->setMinimumSize(0,0);
  QLabel_hostconf8->setText("mosix-node:");
  QLabel_hostconf8->setMargin(2);

  QLabel_hostconf= new QLabel(hinten1,hostname);
  QLabel_hostconf->setGeometry(100,60,120,20);
  QLabel_hostconf->setMinimumSize(0,0);
  QLabel_hostconf->setMargin(2);
  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );
  QLabel_hostconf->setText(hostname);
  QLabel_hostconf->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
		}




  QLabel_hostconf1= new QLabel(hinten1,"conf1");
  QLabel_hostconf1->setGeometry(100,100,140,20);
  QLabel_hostconf1->setMinimumSize(0,0);
  QLabel_hostconf1->setText("auto-migration on/off");
  QLabel_hostconf1->setMargin(2);

  QLabel_hostconf6= new QLabel(hinten1,"quiet");
  QLabel_hostconf6->setGeometry(100,120,140,20);
  QLabel_hostconf6->setMinimumSize(0,0);
  QLabel_hostconf6->setText("talk to others nodes");
  QLabel_hostconf6->setMargin(2);

  QLabel_hostconf2= new QLabel(hinten1,"conf2");
  QLabel_hostconf2->setGeometry(100,140,140,20);
  QLabel_hostconf2->setMinimumSize(0,0);
  QLabel_hostconf2->setText("local procs stay");
  QLabel_hostconf2->setMargin(2);

  QLabel_hostconf3= new QLabel(hinten1,"conf3");
  QLabel_hostconf3->setGeometry(100,160,140,20);
  QLabel_hostconf3->setMinimumSize(0,0);
  QLabel_hostconf3->setText("send away guest procs");
  QLabel_hostconf3->setMargin(2);

  QLabel_hostconf4= new QLabel(hinten1,"conf4");
  QLabel_hostconf4->setGeometry(100,180,140,20);
  QLabel_hostconf4->setMinimumSize(0,0);
  QLabel_hostconf4->setText("MOSIX start/stop");
  QLabel_hostconf4->setMargin(2);

	hinten1->show();


	if(QCheckBox_3->isChecked()) {

if (inet_aton(hostname, &num)!=0) {

        host=gethostbyaddr((char*)&num, sizeof(num), AF_INET);
        ip=(struct in_addr**)host->h_addr_list;
				hostname2=host->h_name;

			  QLabel_hostconf->setText(hostname2);
			  QLabel_hostconf->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
			  QLabel_hostconf7->setText(hostname);
			  QLabel_hostconf7->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        } else {

        host=gethostbyname(hostname);
        ip=(struct in_addr**)host->h_addr_list;
				sprintf(ipaddr, "%s",inet_ntoa(**ip));

			  QLabel_hostconf->setText(hostname);
			  QLabel_hostconf->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
			  QLabel_hostconf7->setText(ipaddr);
			  QLabel_hostconf7->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }


		} else {}

}






void widgetMain::typval() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


	if(QCheckBox_4->isChecked()) {


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;

		}



	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/load");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if (nummerint!=-101) {
					if (nummerint<widgetMain::QProgressBar_host[status-1]->progress()) {
					widgetMain::QProgressBar_host[status-1]->reset ();
					widgetMain::QProgressBar_host[status-1]->setProgress(nummerint);
					} else {
					widgetMain::QProgressBar_host[status-1]->setProgress(nummerint);
							}
					}
		fclose(zahl);
		}
	}


		}

}







void widgetMain::getval() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;

		}



	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/speed");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if(nummerint<0) { nummerint=0; }
					widgetMain::QSlider_host[status-1]->setValue(nummerint);
					widgetMain::QLCDNumber_host[status-1]->display(nummerint);

		fclose(zahl);
		}
	}


}





void widgetMain::setspeed(int speed) {

	char mosspeed[6]="";
	char setsp[100]="";
	char outp[100]="";
	int error;
	const  char *hostname;
	const QObject *button = sender();



	hostname=button->name();

	if (speed<0) {
  	speed=0;
	}

	sprintf(mosspeed, "%d", speed);

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl setspeed ");
	strcat(setsp, mosspeed);

	if((error=system(setsp)) > 0) {
        printf("cannot set mosspeed\n");

	strcpy(outp, "cannot set speed to ");
	strcat(outp, mosspeed);
	strcat(outp, " on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        } else {

	strcpy(outp, "set speed to ");
	strcat(outp, mosspeed);
	strcat(outp, " on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

                }




}









void widgetMain::action_stop() {

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_90-> setToggleButton ( TRUE );
	QPushButton_90-> toggle();
	QPushButton_80-> toggle ();
	QPushButton_80-> setToggleButton ( FALSE );

	strcpy(outp, "stopping mosix on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/rc.d/init.d/mosix stop");
	if((error=system(setsp)) > 0) {
        printf("cannot stop mosix\n");

				strcpy(outp, "cannot stop mosix on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }


}







void widgetMain::action_start() {

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_80-> setToggleButton ( TRUE );
	QPushButton_80-> toggle();
	QPushButton_90-> toggle ();
	QPushButton_90-> setToggleButton ( FALSE );

	strcpy(outp, "starting mosix on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/rc.d/init.d/mosix start");
	if((error=system(setsp)) > 0) {
        printf("cannot start mosix\n");

				strcpy(outp, "cannot start mosix on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }


}












void widgetMain::action_lstay(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_30-> setToggleButton ( TRUE );
	QPushButton_30-> toggle();
	QPushButton_40-> toggle ();
	QPushButton_40-> setToggleButton ( FALSE );

	strcpy(outp, "local processes return to ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl bring");
	if((error=system(setsp)) > 0) {
        printf("cannot set -lstay\n");

				strcpy(outp, "cannot return local processes to ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }

}





void widgetMain::action_nolstay(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_40-> setToggleButton ( TRUE );
	QPushButton_40-> toggle();
	QPushButton_30-> toggle ();
	QPushButton_30-> setToggleButton ( FALSE );

	strcpy(outp, "local processes can migrate on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));




	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -lstay");
	if((error=system(setsp)) > 0) {
        printf("cannot set -lstay\n");

				strcpy(outp, "allowing local processes to migrate failed on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }

}





void widgetMain::action_migration(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_2->setToggleButton ( TRUE );
	QPushButton_2->toggle();
	QPushButton_12->toggle ();
	QPushButton_12->setToggleButton ( FALSE );

	strcpy(outp, "auto-migration enabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -stay");
	if((error=system(setsp)) > 0) {
        printf("cannot set -stay\n");

				strcpy(outp, "failed to set auto-migration enabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }


}





void widgetMain::action_nomigration(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_12-> setToggleButton ( TRUE );
	QPushButton_12-> toggle ();
	QPushButton_2-> toggle();
	QPushButton_2-> setToggleButton ( FALSE );

	strcpy(outp, "auto-migration disabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl stay");
	if((error=system(setsp)) > 0) {
        printf("cannot set stay\n");
	
				strcpy(outp, "failed to disable auto-migration on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }


}








void widgetMain::action_block(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_50-> setToggleButton ( TRUE );
	QPushButton_50-> toggle();
	QPushButton_60-> toggle ();
	QPushButton_60-> setToggleButton ( FALSE );

	strcpy(outp, "blocking enabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl expel");
	if((error=system(setsp)) > 0) {
        printf("cannot set expel\n");

				strcpy(outp, "failed to set blocking enabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }

}






void widgetMain::action_noblock(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_60-> setToggleButton ( TRUE );
	QPushButton_60-> toggle();
	QPushButton_50-> toggle ();
	QPushButton_50-> setToggleButton ( FALSE );

	strcpy(outp, "blocking disabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -block");
	if((error=system(setsp)) > 0) {
        printf("cannot set -block\n");

				strcpy(outp, "failed to set blocking disabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
        }


}




void widgetMain::action_noquiet(){


	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_91-> setToggleButton ( TRUE );
	QPushButton_91-> toggle();
	QPushButton_81-> toggle ();
	QPushButton_81-> setToggleButton ( FALSE );

	strcpy(outp, "auto load-dissemination stopped on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl quiet");
	if((error=system(setsp)) > 0) {
        printf("cannot set quiet\n");

				strcpy(outp, "failed to execute mosctl quiet on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

        }

}






void widgetMain::action_quiet(){



	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

	hostname=button->name();

	QPushButton_81-> setToggleButton ( TRUE );
	QPushButton_81-> toggle();
	QPushButton_91-> toggle ();
	QPushButton_91-> setToggleButton ( FALSE );

	strcpy(outp, "auto load-dissemination resumed on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -quiet");
	if((error=system(setsp)) > 0) {
        printf("cannot execute mosctl -quiet\n");

				strcpy(outp, "failed to execute mosctl -quiet on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));
        }


}







void widgetMain::neuwin(){

	processbox = new QListView(this);
	processbox->setGeometry(470,20,50,100);
	processbox->setMinimumSize(0,0);
	processbox->setAllColumnsShowFocus(1);
	processbox->addColumn("pid");
	processbox->addColumn("n#");
	processbox->addColumn("stat");
	processbox->addColumn("cmdline");


	processbox->setSorting(2, TRUE);

	processbox->setColumnAlignment (0, AlignLeft);
	processbox->setColumnAlignment (1, AlignLeft);
	processbox->setColumnAlignment (2, AlignLeft);
	processbox->setItemMargin(2);
	processbox->resize(190, 300);
	fill_procbox();
	processbox->show();
	QObject::connect( processbox, SIGNAL(doubleClicked(QListViewItem *)), this, SLOT( labelit( QListViewItem *)) );


  QWhatsThis::add(processbox,"This box shows the running processes.\nThe number in the column n# is the MOSIX-node\nthe process is running on.\n(0 is this host)\nDoubleclick a process to migrate it!");


}



	void widgetMain::labelit( QListViewItem *index) {

	char mapentry[LENGTH];
	char *leer1="0";
	int counter=0;
	FILE *fp;
	int character='#';
	int character1=' ';
	int character2='\t';
	int lang=0;
	char hostname[256][LENGTH];
	char hostrange[256][LENGTH];
	char many[256][LENGTH];
	int howmany=0;
  char *sub_string;
  char *sub_string1;
	int pi=0;
	char pc[3];
	int range=0;

	char tmp[256][LENGTH];
	int j=0;
	int p=0;

	char output[250];
	int k=0;







	hinten = new QWidget(0, "");
	hinten->setGeometry(500,300,50,110);
	hinten->setMinimumSize(0,0);
	hinten->resize(170, 210);

	QGroupBox *backr2 = new QGroupBox("",hinten);
	backr2->setGeometry(5,5,50,130);
	backr2->setMinimumSize(0,0);
	backr2->resize(160, 200);

	QLabel *QLabel_proc = new QLabel("",backr2);
	QLabel_proc->setGeometry(10,90,20,30);
	QLabel_proc->setMinimumSize(0,0);
	QLabel_proc->resize(140, 100);




	QListBox *hostbox = new QListBox(hinten);
	hostbox->setGeometry(10,10,50,110);
	hostbox->setMinimumSize(0,0);
	hostbox->resize(150, 100);






	for(k=0;k<256;k++) {
	strcpy(hostname[k], "");

	}


        if ((fp=fopen("/etc/mosix.map", "r"))==NULL) {
        printf("This is not MOSIX\n");
				exit(1);
        }

        while (!feof(fp)) {

                        fgets(mapentry, LENGTH, fp);

                        if ( ((strchr(mapentry, character))==NULL)&&((strlen(mapentry))>1) ) {
		                     if ((leer1=strchr(mapentry, character2))==NULL) {
                                leer1=strchr(mapentry, character1);
						                    leer1++;
            				            strcpy(tmp[counter], leer1);
                    				    lang=strcspn(tmp[counter], " ");



														    } else {
						                    leer1++;
            				            strcpy(tmp[counter], leer1);
                    				    lang=strcspn(tmp[counter], "\t");
																																		}

														
	range=0;
	strcpy(many[counter], leer1);																
  printf("%s\n", strtok(many[counter], " "));
	sub_string=strtok(NULL, " ");
	

	howmany=atoi(sub_string);
	if (howmany!=1) {

	range=1;
	for (p=0; p<=howmany-1; p++) {

 		                    strncpy(hostrange[counter], leer1, lang);
												  printf("%s\n", strtok(hostrange[counter], "."));
													sub_string1=strtok(NULL, ".");
													sub_string1=strtok(NULL, ".");
													sub_string1=strtok(NULL, ".");

                        	pi=atoi(sub_string1);
													pi=pi+p;

												sprintf(pc, "%d", pi);

	 											while(j<LENGTH) {
												hostname[counter][j]=0;
												j++;
                                   }

 		                    strncpy(hostname[counter], leer1, lang-(strlen(sub_string1)));
												strcat(hostname[counter], pc);

												hostbox->insertItem(hostname[counter]);

                        counter++;

												j=0;

					}

		}



           						if(range==0) {
  											while(j<LENGTH) {
												hostname[counter][j]=0;
												j++;
                                    }
	                      strncpy(hostname[counter], leer1, lang);

												hostbox->insertItem(hostname[counter]);

                        counter++;
												j=0;
																		}
  	                    }
               }

        fclose(fp);




	hostbox->show();

	QObject::connect( hostbox, SIGNAL(selected(int)), this, SLOT( migrateto( int )) );

	QLabel_50->setText(index->text(0));
	QLabel_50->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/white.gif"));

	strcpy(output, "");
	strcpy(output, "doubleclick a mosix host \nfor migrating the process:\n");
		strcat(output, index->text(0));
		strcat(output, " (");
	strcat(output, index->text(1));
	strcat(output, ")\n");
	QLabel_proc->setText(output);

  QPushButton_71= new QPushButton(hinten,"cancel");
  QPushButton_71->setGeometry(95,175,60,20);
  QPushButton_71->setMinimumSize(0,0);
  QPushButton_71->setText("cancel");
	QObject::connect( QPushButton_71, SIGNAL(clicked()), this, SLOT( closehostbox()) );

  QPushButton_72= new QPushButton(hinten,"kill");
  QPushButton_72->setGeometry(15,175,60,20);
  QPushButton_72->setMinimumSize(0,0);
  QPushButton_72->setText("kill");
	QObject::connect( QPushButton_72, SIGNAL(clicked()), this, SLOT( killproc()) );

	hinten->show();


  QWhatsThis::add(backr2,"To migrate this process to a specific MOSIX-node\njust doubleclick this host from the hostlist.\n(or kill to kill this process!)");
  QWhatsThis::add(hostbox,"To migrate this process to a specific MOSIX-node\njust doubleclick this host from the hostlist.\n(or kill to kill this process!)");


	}





	void widgetMain::migrateto(int index) {

	char setsp[100]="";
	int error;
	char cindex[5];
	const	char *cproc;


	cproc=QLabel_50->text();
	delete hinten;


		index++;
		strcpy(cindex, "");
		sprintf(cindex, "%d", index);

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " ");

	strcat(setsp, cindex);
	if((error=system(setsp)) > 0) {
        printf("cannot migrate PID\n");
        }


}





	void widgetMain::refreshit() {

	if(QCheckBox_1->isChecked()) {
		fill_procbox();
		}

}



	void widgetMain::refreshitmanual() {

		fill_procbox();

}




	void widgetMain::refreshit_status() {

	if(QCheckBox_2->isChecked()) {
		mosixstatus();
		}

	}



	void widgetMain::refreshit_status_manual() {
		mosixstatus();
	}






	void widgetMain::fill_procbox() {

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
	char cmdline[1000];
	char temp[1000];
	char where[5];
	char stat[1000];


	processbox->clear();

	if ((dir=opendir("/proc"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {


	if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/cmdline");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", cmdline);
            fclose(fp);
        }

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/where");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", where);
            fclose(fp);
        }



        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/stat");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fclose(fp);
        }





		QListViewItem *i1;
		i1 = new QListViewItem(processbox, dir_info->d_name, where, stat, cmdline);

    }

	} //while

} //if


}




	void widgetMain::closehostbox() {

	delete hinten;
}


	void widgetMain::close_config() {

	delete hinten1;
}



	void widgetMain::killproc() {

	char killprocnr[50];
	int error;

	strcpy(killprocnr, "");
	strcpy(killprocnr, "/bin/kill ");
	strcat(killprocnr, QLabel_50->text());
	if((error=system(killprocnr)) > 0) {
        printf("cannot kill proc\n");
        }

}








	void widgetMain::mosixstatus() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;
		}



	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/speed");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if(nummerint>=2) {
							QLabel_stat[status-1]->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/green.gif"));
											 } else {
							QLabel_stat[status-1]->setBackgroundPixmap(QPixmap("/root/Projects/mosixview/mosixview/red.gif"));
												}
		fclose(zahl);
		}
	}

}





	void widgetMain::labelconf() {



QLabel_50->setFrameStyle( QFrame::Panel | QFrame::Sunken );
QLabel_50->setAlignment( AlignVCenter | AlignRight );


QLabel_111->setFrameStyle( QFrame::Panel | QFrame::Sunken );


QScrollBar_1->setSteps ( 60,320 );




QWhatsThis::add(QPushButton_70,"To refresh the processbox manualy click this button.\n");
QWhatsThis::add(QCheckBox_1,"If checked the processbox refreshs automaticaly.\n");

QWhatsThis::add(QLabel_50,"Contains the PID of the last-managed process.\n");
QWhatsThis::add(QLabel_111,"This box shows the output of the MOSIX-commands.\n");



QWhatsThis::add(this,"Control your MOSIX-Cluster with MOSIXVIEW.\nThis GUI will help you manage the configuration, load and process-migration.\n");

}












